"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@lincode/utils");
const react_1 = require("react");
exports.default = (cb) => {
    const [dropEl, setDropEl] = react_1.useState();
    const [dragOver, setDragOver] = react_1.useState(false);
    react_1.useEffect(() => {
        if (!dropEl)
            return;
        const setDragOverDebounced = utils_1.debounce((value) => setDragOver(value), 100, "trailing");
        let valueOld = false;
        const setDragOverTrack = (value) => {
            if (valueOld === value)
                return;
            valueOld = value;
            setDragOverDebounced(value);
        };
        const dragOverCb = (e) => {
            e.preventDefault();
            setDragOverTrack(true);
        };
        dropEl.addEventListener("dragover", dragOverCb);
        const dragEnterCb = (e) => {
            e.preventDefault();
            setDragOverTrack(true);
        };
        dropEl.addEventListener("dragenter", dragEnterCb);
        const dragLeaveCb = (e) => {
            e.preventDefault();
            setDragOverTrack(false);
        };
        dropEl.addEventListener("dragleave", dragLeaveCb);
        const dropCb = (e) => {
            e.preventDefault();
            setDragOverTrack(false);
            cb(e);
        };
        dropEl.addEventListener("drop", dropCb);
        return () => {
            dropEl.removeEventListener("dragover", dragOverCb);
            dropEl.removeEventListener("dragenter", dragEnterCb);
            dropEl.removeEventListener("dragleave", dragLeaveCb);
            dropEl.removeEventListener("drop", dropCb);
        };
    }, [dropEl]);
    return [setDropEl, dragOver];
};
